Index: pdns/backends/gsql/gsqlbackend.cc
===================================================================
--- pdns/backends/gsql/gsqlbackend.cc	(revision 1740)
+++ pdns/backends/gsql/gsqlbackend.cc	(working copy)
@@ -315,6 +315,14 @@
   
   // lcqname=labelReverse(makeRelative(lcqname, "net"));
 
+  string localIP="0.0.0.0";
+  string remoteIP="0.0.0.0";
+
+  if (pkt_p) {
+    localIP=pkt_p->getLocal();
+    remoteIP=pkt_p->getRemote();
+  }
+
   if(qtype.getCode()!=QType::ANY) {
     // qtype qname domain_id
     if(domain_id<0) {
@@ -323,14 +331,14 @@
       else
         format=d_noWildCardNoIDQuery;
 
-      snprintf(output,sizeof(output)-1, format.c_str(),sqlEscape(qtype.getName()).c_str(), sqlEscape(lcqname).c_str());
+      snprintf(output,sizeof(output)-1, format.c_str(),sqlEscape(qtype.getName()).c_str(), sqlEscape(lcqname).c_str(), remoteIP.c_str(), localIP.c_str());
     }
     else {
       if(qname[0]!='%')
         format=d_noWildCardIDQuery;
       else
         format=d_wildCardIDQuery;
-      snprintf(output,sizeof(output)-1, format.c_str(),sqlEscape(qtype.getName()).c_str(),sqlEscape(lcqname).c_str(),domain_id);
+      snprintf(output,sizeof(output)-1, format.c_str(),sqlEscape(qtype.getName()).c_str(),sqlEscape(lcqname).c_str(),domain_id,remoteIP.c_str(),localIP.c_str());
     }
   }
   else {
@@ -342,14 +350,14 @@
       else
         format=d_noWildCardANYNoIDQuery;
 
-      snprintf(output,sizeof(output)-1, format.c_str(),sqlEscape(lcqname).c_str());
+      snprintf(output,sizeof(output)-1, format.c_str(),sqlEscape(lcqname).c_str(),remoteIP.c_str(),localIP.c_str());
     }
     else {
       if(qname[0]!='%')
         format=d_noWildCardANYIDQuery;
       else
         format=d_wildCardANYIDQuery;
-      snprintf(output,sizeof(output)-1, format.c_str(),sqlEscape(lcqname).c_str(),domain_id);
+      snprintf(output,sizeof(output)-1, format.c_str(),sqlEscape(lcqname).c_str(),domain_id,remoteIP.c_str(),localIP.c_str());
     }
   }
   DLOG(L<< "Query: '" << output << "'"<<endl);